#pragma once

#include <utils.h>

class Renderable
{
public:
	Renderable();
	~Renderable(void);

	virtual void Render(float zValue) = 0;
	virtual void UpdateTexture() = 0;

	virtual void ChangeParameter(float newParameter){}
	virtual void IncrementParameter(float deltaParameter){}

	void Initialize(LayerManager* manager, int width, int height);

	char *FriendlyName;

protected:
	virtual void InternalInitialize(){}
	virtual void SetFriendlyName() = 0;

	int m_width, m_height;
	LayerManager* m_layerManager;
};